var SU_ClientLitebar=function(){this.api=new SU_Client();
this.apiInitialized=false;
this.currentStumble=null;
this.currentStaticUrl=null;
this.stumblingMode={};
this.currentUser=null;
this.sidecarData=null;
this.errorState=null;
this.keychain=null;
this.credentialsFetchedTime=0;
this.data={};
return true
};
SU_ClientLitebar.prototype={init:function(){this.ensureKeychainExists();
this.bindListeners()
},bindListeners:function(){throw"Must implement bindListeners in implementation class"
},setData:function(a,b,c){throw"Must implement setData in implementation class"
},getData:function(a,b){throw"Must implement getData in implementation class"
},getLocation:function(a){throw"Must implement getLocation in implementation class"
},setKeychain:function(a){this.keychain=a;
this.setData("keychain",a)
},ensureKeychainExists:function(){throw"Must implement ensureKeychainExists in implementation class"
},handleSidecarData:function(a){if(!a||typeof a.auxData=="undefined"){return false
}this.sidecarData=a.auxData;
if(typeof a.auxData.updateClient!="undefined"){this.setData("performClientUpdate",1)
}},setAuth:function(a){this.keychain.authString=a
},setupApi:function(d,c){var a=this;
var b=function(){a.api.setDevice(a.device);
a.api.setSource(a.source);
a.api.setKeychain(a.keychain);
if(typeof a.clientVersion!="undefined"){a.api.setClientVersion(a.clientVersion)
}a.api.setScriptVersion(a.scriptVersion);
a.apiInitialized=true;
if(d){d()
}};
if(c){this.keychain=new SU_ClientRequestKeychain();
b()
}else{this.api.setDevice(this.device);
this.api.setSource(this.source);
this.ensureKeychainExists(function(){b()
})
}},performShareStumble:function(b){var a=this;
this.setActiveStumble(null);
this.setActiveStaticUrl(null);
this.setupApi(function(){a.api.getShare(function(c){a.setActiveStumble(c);
a.handleSidecarData(c);
a.updateUI();
if(b){b(c)
}})
})
},performStumble:function(b){var a=this;
this.setActiveStumble(null);
this.setActiveStaticUrl(null);
this.setupApi(function(){a.api.getStumble(a.stumblingMode,function(c){a.setActiveStumble(c);
a.handleSidecarData(c);
a.updateUI();
if(b){b(c)
}})
})
},performStumbleDirect:function(c,b){var a=this;
this.setActiveStumble(null);
this.setActiveStaticUrl(null);
this.setupApi(function(){var f=a.stumblingMode;
if(c){for(var e in c){f[e]=c[e]
}}var d=a.api.getStumble(f);
b(d)
})
},performRating:function(b,c){var a=this;
this.setupApi(function(){if(a.currentStumble){if(typeof a.currentStumble.rating!="undefined"&&a.currentStumble.rating==b){b=-1
}a.api.rate(a.currentStumble.publicid,b,c);
a.currentStumble.rating=b;
a.updateUI()
}})
},getUserData:function(b){var a=this;
this.setupApi(function(){a.api.getUserData(function(c){if(c){a.setActiveUser(c.info);
a.updateUI();
if(b){b(c)
}}})
})
},getRequestToken:function(b){this.setupApi();
var a=this;
this.api.getRequestToken(function(c){if(b){b(c)
}})
},getUrlInfo:function(b,c){var a=this;
this.setupApi(function(){a.api.getUrlInfo(b,c)
})
},checkForShares:function(a){this.setupApi();
this.api.checkForShares(a)
},sendShare:function(a,b){this.setupApi();
this.api.sendShare(a,b)
},logoutWebsite:function(a){this.setupApi();
this.api.logoutWebsite(a)
},trk:function(a){this.setupApi();
this.api.trk(a,function(){})
},resetStumblingMode:function(a){this.stumblingMode={};
this.setData("stumblingMode",this.stumblingMode,a)
},setStumblingMode:function(a,b){this.stumblingMode=a;
this.setData("stumblingMode",this.stumblingMode,function(){if(b){b(a)
}})
},setStumblingMethod:function(c,a){this.resetStumblingMode();
this.stumblingMode.method=c;
delete this.stumblingMode.extra;
if(a){this.stumblingMode.extra={};
for(var b in a){this.stumblingMode.extra[b]=a[b]
}}},setStumblingTopic:function(a,b){if(a==0){this.setStumblingMethod("general")
}else{this.setStumblingMethod("topic")
}this.stumblingMode.topic=a;
this.setData("stumblingMode",this.stumblingMode,b)
},getActiveStumble:function(){return this.currentStumble
},setActiveStumble:function(a){this.currentStaticUrl=null;
this.currentStumble=a
},setActiveStaticUrl:function(a){this.currentStumble=null;
this.currentStaticUrl=a
},setActiveUser:function(a){this.currentUser=a
},setModeLabel:function(a,b){$("#topics a").html(a);
if(a=="All topics"){$("#topics").removeClass("cancel").addClass("default")
}else{$("#topics").removeClass("default").addClass("cancel")
}this.setData("stumblingModeLabel",a,b)
},updateUI:function(){if(this.errorState){this.updateUI_Error()
}if(this.currentStumble){this.updateUI_StumbleUrl();
this.updateUI_StumbleMeta()
}this.updateUI_User();
if(this.sidecarData){for(var a=0;
a<this.sidecarData.length;
a++){var b=this.sidecarData[a];
if(b.type=="message"){this.displayMessage(b)
}}}this.updateUI_CacheInterfaceState()
},updateUI_StumbleUrl:function(){throw"Must implement updateUI_StumbleUrl"
},updateUI_StumbleMeta:function(){throw"Must implement updateUI_StumbleMeta"
},handleErrorState:function(a){return false
},debugText:function(a){if(typeof console!="undefined"){console.log(a)
}},gotoUrlPage:function(){if(this.currentStumble){this.gotoUrl(this.currentStumble.info_link)
}else{var a=this;
this.performUrlLookup(function(b){if(b){if(b.known){a.gotoUrl(b.info_link)
}else{a.displayMessage({display:"tooltip",message:"At the moment, we don't know about this site. Thumb it up to discover it!",subject:$("#reviews"),config:{permanence:"fade10"}})
}}})
}},ratingCallback:function(a,b){if(a.new_rating==-1){if(this.currentUser){this.currentUser.favorites--;
this.setData("userInfo",this.currentUser)
}}else{if(this.currentUser){this.currentUser.favorites++;
this.setData("userInfo",this.currentUser)
}else{this.setData("pendingRating",{publicid:this.currentStumble.publicid,rating:1});
this.toggleLoginUI()
}}this.updateUI_User();
if(b){b()
}},toggleTwitterShareUI:function(){var b="sutweet";
var c="";
var d=window.open(c,b,"width=800px,height=500px");
var a=this;
var e=function(h,g){var f="/to/event/webtb_twittershare/?url="+encodeURIComponent(h);
if(g){f+="&extra="+encodeURIComponent(g+" ")
}d.location.href=f;
d.focus();
a.trk("twitterShareClick")
};
if(!this.currentStumble){this.getLocation(e)
}else{e(this.currentStumble.url,this.currentStumble.title)
}},toggleFacebookShareUI:function(){var b="sufb";
var c="";
var d=window.open(c,b,"width=620px,height=550px");
var a=this;
var e=function(g){var f="/to/event/webtb_facebookshare/?url="+encodeURIComponent(g);
d.location.href=f;
d.focus();
a.trk("facebookShareClick")
};
if(!this.currentStumble){this.getLocation(e)
}else{e(this.currentStumble.url,this.currentStumble.title)
}},userInterfaceEvents:{buttonTooltipClick:{target:".tips",action:"click.tips",handler:function(a){a.data.instance.hideHoverTip($(this))
}},stumble:{target:"#stumble",action:"click",handler:function(a){a.data.instance.performStumble();
return false
}},thumbUp:{target:"#like",action:"click",handler:function(a){if(a.data.instance.currentStumble){a.data.instance.performRating(1,function(b){a.data.instance.ratingCallback(b)
})
}else{a.data.instance.performUrlLookup(function(b){if(b.known){a.data.instance.setActiveStumble(b);
a.data.instance.performRating(1,function(c){a.data.instance.ratingCallback(c)
})
}else{a.data.instance.gotoUrl("/submit?url="+encodeURIComponent(b.url))
}})
}return false
}},thumbDown:{target:"#notLike",action:"click",handler:function(a){if(a.data.instance.currentStumble){a.data.instance.performRating(0)
}else{a.data.instance.performUrlLookup(function(b){if(b.known){a.data.instance.setActiveStumble(b);
a.data.instance.performRating(0)
}else{a.data.instance.displayMessage({display:"tooltip",message:"Nobody has discovered this page yet, so it cannot be thumbed down",subject:$("#notLike"),config:{permanence:"fade10"}})
}})
}return false
}},shareMenuToggle:{target:"#share",action:"click",handler:function(a){a.data.instance.toggleShareUI();
a.data.instance.trk("normalShareClick");
return false
}},topicsMenuToggle:{target:"#topics",action:"click",handler:function(a){a.data.instance.toggleTopicSelectorUI();
return false
}},topicDeselection:{target:"#topics.cancel .bgImgRight",action:"click",handler:function(a){if($("#topics").hasClass("cancel")){a.data.instance.resetStumblingMode();
a.data.instance.setStumblingMode({});
a.data.instance.setModeLabel("All topics");
if(a.data.instance.device=="chromebar"){suExtensionApi.message.broadcastMessage("localUpdateStumblingTopic",{id:0,name:"All topics"})
}if(typeof a.data.instance.hideViewPane!="undefined"){a.data.instance.hideViewPane(a.data.instance.viewPanes.topics)
}a.data.instance.performStumble()
}else{a.data.instance.toggleTopicSelectorUI()
}return false
}},seeUrlInfo:{target:"#reviews",action:"click",handler:function(a){a.data.instance.gotoUrlPage();
return false
}},facebookShare:{target:"#facebook",action:"click",handler:function(a){a.data.instance.toggleFacebookShareUI();
return false
}},twitterShare:{target:"#twitter",action:"click",handler:function(a){a.data.instance.toggleTwitterShareUI();
return false
}},emailShare:{target:"#email",action:"click",handler:function(a){a.data.instance.toggleMailUI();
a.data.instance.trk("emailShareClick");
return false
}},showUserInfo:{target:"#friends",action:"click",handler:function(a){}},sponsoredPage:{target:"#sponsored",action:"click",handler:function(a){}},login:{target:"#login",action:"click",handler:function(a){a.data.instance.toggleLoginUI();
return false
}},logout:{target:"#logout",action:"click",handler:function(a){a.data.instance.displayMessage({display:"tooltip",message:"Are you sure?",subject:$(this),config:{permanence:"close",buttons:[{label:"Yes, I know my password",action:"logoutConfirmClicked",style:"plain"}]}});
return false
}},favoritesLoggedOut:{target:"#favorites_l",action:"click",handler:function(a){a.data.instance.gotoUrl("/signup/?pre=wtb_savefavs");
return false
}},favoritesLoggedOutVideo:{target:"#favorites_l_video",action:"click",handler:function(a){a.data.instance.gotoUrl("/signup/?pre=video_wtb_savefavs");
return false
}},favoritesLoggedIn:{target:"#favorites",action:"click",handler:function(a){a.data.instance.gotoUrl("/favorites/");
return false
}},homeButton:{target:"#goHome",action:"click",handler:function(a){a.data.instance.gotoUrl("/");
return false
}},closeButton:{target:"#close",action:"click",handler:function(a){if(a.data.instance.currentStumble){a.data.instance.gotoUrl(a.data.instance.currentStumble.url)
}else{a.data.instance.gotoUrl("/")
}return false
}},buttonTooltipOn:{target:".tips",action:"mouseenter.tips",handler:function(a){a.data.instance.showHoverTip($(this))
}},buttonTooltipOff:{target:".tips",action:"mouseleave.tips",handler:function(a){a.data.instance.hideHoverTip($(this))
}}}};